<script lang="ts">
import {productPerformance} from '@/data/dashboard/dashboardData';

export default {
    data(): any {
        return {
            products: [],
            loading: true
        }
    },
    async mounted() {
        this.getProducts();
    },
    methods: {
        async deleteProduct(id: number) {
            await fetch('http://localhost:8000/api/produits/' + id, {
                method: 'DELETE',
                headers: {
                    'Content-Type': 'application/json',
                }
            });
            this.getProducts();
        },
        async getProducts() {
            const response = await fetch('http://localhost:8000/api/produits', {
                method: 'GET',
                headers: {
                    'Content-Type': 'application/json',
                }
            });
            const responseData = await response.json();
            this.products = responseData['hydra:member'];
            this.loading = false;
        }
    }
};

</script>

<template>
    <v-row align="center">
        <v-col cols="12" lg="3">
            <h1>Liste des produits</h1>
        </v-col>

        <v-col cols="12" lg="7">
            <v-btn to="/products/create" color="primary" variant="outlined">Créer un produit</v-btn>
        </v-col>

        <v-col cols="12">
            <v-row>
                <v-col cols="12" lg="12">
                    <v-card elevation="10" class="">
                        <v-card-item class="py-2 px-4">
                            <v-table class="month-table">
                                <thead>
                                    <tr>
                                        <th class="text-subtitle-1 font-weight-bold">Id</th>
                                        <th class="text-subtitle-1 font-weight-bold">Nom</th>
                                        <th class="text-subtitle-1 font-weight-bold">Description</th>
                                        <th class="text-subtitle-1 font-weight-bold text-right">Prix</th>
                                        <th class="text-subtitle-1 font-weight-bold text-right"></th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr v-for="item in products" :key="item.id" class="month-item">
                                        <td>
                                            <p class="text-15 font-weight-medium">{{ item.id }}</p>
                                        </td>
                                        <td>
                                            <div class="">
                                                <h6 class="text-subtitle-1 font-weight-bold">{{ item.nom }}</h6>
                                            </div>
                                        </td>
                                        <td>
                                            <h6 class="text-body-1 text-muted">{{ item.description }}</h6>
                                        </td>
                                        <td>
                                            <h6 class="text-h6 text-right">{{ item.prix }}</h6>
                                        </td>
                                        <td class="text-right">
                                            <v-btn @click="deleteProduct(item.id)" color="primary" variant="outlined">Supprimer</v-btn>
                                        </td>
                                    </tr>
                                </tbody>
                            </v-table>
                            <div class="container-loader">
                                <div v-if="loading" class="loader"></div>
                            </div>
                        </v-card-item>
                    </v-card>
                </v-col>
            </v-row>
        </v-col>
    </v-row>
</template>

<style scoped>
    .container-loader{
        display: flex;
        justify-content: center;
        align-items: center;
        width: 100%;
    }
    .loader {
        position: relative;
        width: 50px;
        height: 50px;
        border: 3px solid rgb(255,111,0);
        border-radius: 50%;
        border-top-color: transparent;
        animation: spin 1s linear infinite;
        margin: auto auto;
    }
    @keyframes spin {
        0% { transform: rotate(0deg); }
        100% { transform: rotate(360deg); }
    }
</style>